//
//  CommonHelper.m
//  TableViewFull
//
//  Created by SunLi on 16/3/29.
//  Copyright © 2016年 lb. All rights reserved.
//

#import "CommonHelper.h"

@implementation CommonHelper

#pragma string 字符串操作
+ (BOOL)isEmptyOrNull: (NSString *)string
{
    if (string == nil || [string isEqualToString:@""])
        return true;
    return false;
}
+ (BOOL)isNotEmptyAndNull: (NSString *)string
{
    if (string != nil && ![string isEqualToString:@""])
        return  true;
    return false;
}
+ (NSString *)stringFromInteger:(NSInteger)integer
{
    return [NSString stringWithFormat:@"%@", @(integer)];
}

#pragma mark 消息提示框

+ (void)showAlert:(NSObject *)controller andTitle:(NSString *)title andMessage:(NSString *)message{
    UIAlertView *alert = [[UIAlertView alloc]initWithTitle:title message:message delegate:controller cancelButtonTitle:@"取消" otherButtonTitles:nil];
    [alert show];
}

+ (void)showAlert:(NSObject *)controller andTitle:(NSString *)title andMessage:(NSString *)message andCancleTitle:(NSString *)cancleTitle{
    UIAlertView *alert = [[UIAlertView alloc]initWithTitle:title message:message delegate:controller cancelButtonTitle:cancleTitle otherButtonTitles:nil];
    [alert show];
}

#pragma mark 颜色操作
+ (UIColor *)rgb:(CGFloat)r andg:(CGFloat)g andb:(CGFloat)b
{
    return [UIColor colorWithRed:r/255.0f green:g/255.0f blue:b/255.0f alpha:1.0f];
}
+ (UIColor *)rgba:(CGFloat)r andg:(CGFloat)g andb:(CGFloat)b anda:(CGFloat)a
{
    return [UIColor colorWithRed:r/255.0f green:g/255.0f blue:b/255.0f alpha:a];
}
//16进制字符串
+ (UIColor *)hexColor:(NSString *)color
{
    return [self colorWithHexString:color alpha:1.0f];
}
//包含alpha通道的16进制字符串
+ (UIColor *)hexColorAlpha:(NSString *)color andAlpha:(CGFloat)alpha
{
    return [self colorWithHexString:color alpha:alpha];
}

+ (UIColor *)colorWithHexString:(NSString *)color alpha:(CGFloat)alpha
{
    //删除字符串中的空格
    NSString *cString = [[color stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]] uppercaseString];
    // String should be 6 or 8 characters
    if ([cString length] < 6)
    {
        return [UIColor clearColor];
    }
    // strip 0X if it appears
    //如果是0x开头的，那么截取字符串，字符串从索引为2的位置开始，一直到末尾
    if ([cString hasPrefix:@"0X"])
    {
        cString = [cString substringFromIndex:2];
    }
    //如果是#开头的，那么截取字符串，字符串从索引为1的位置开始，一直到末尾
    if ([cString hasPrefix:@"#"])
    {
        cString = [cString substringFromIndex:1];
    }
    if ([cString length] != 6)
    {
        return [UIColor clearColor];
    }
    
    // 分开r, g, b 子字符串
    NSRange range;
    range.location = 0;
    range.length = 2;
    //r
    NSString *rString = [cString substringWithRange:range];
    //g
    range.location = 2;
    NSString *gString = [cString substringWithRange:range];
    //b
    range.location = 4;
    NSString *bString = [cString substringWithRange:range];
    
    // Scan values
    unsigned int r, g, b;
    [[NSScanner scannerWithString:rString] scanHexInt:&r];
    [[NSScanner scannerWithString:gString] scanHexInt:&g];
    [[NSScanner scannerWithString:bString] scanHexInt:&b];
    return [UIColor colorWithRed:((float)r / 255.0f) green:((float)g / 255.0f) blue:((float)b / 255.0f) alpha:alpha];
}
@end
