//
//  IPhoneScreen.m
//  TableViewFull
//
//  Created by SunLi on 16/4/13.
//  Copyright © 2016年 lb. All rights reserved.
//

#import "IPhoneScreen.h"

@implementation IPhoneScreen

#pragma mark 手机系统和类型的判断
+ (BOOL)iphone4x_3_5{
    return [UIScreen mainScreen].bounds.size.height==480.0f;
}
+ (BOOL)iphone5x_4_0{
    return [UIScreen mainScreen].bounds.size.height==568.0f;
}
+ (BOOL)iphone6_4_7{
    return [UIScreen mainScreen].bounds.size.height==667.0f;
}
+ (BOOL)iphone6Plus_5_5{
    return ([UIScreen mainScreen].bounds.size.height==736.0f || [UIScreen mainScreen].bounds.size.height==414.0f);
}
//手机操作系统判断
+ (float)version{
    return [[[UIDevice currentDevice] systemVersion] floatValue];
}
+ (BOOL)ios9x{
    return [[[UIDevice currentDevice] systemVersion] floatValue] >=9.0f;
}
+ (BOOL)ios8x{
    return [[[UIDevice currentDevice] systemVersion] floatValue] >=8.0f &&
    [[[UIDevice currentDevice] systemVersion] floatValue] < 9.0f;
}
+ (BOOL)ios7x{
    return [[[UIDevice currentDevice] systemVersion] floatValue] >=7.0f &&
     [[[UIDevice currentDevice] systemVersion] floatValue] < 8.0f;
}
+ (BOOL)ios6x{
    return [[[UIDevice currentDevice] systemVersion] floatValue] < 7.0f;
}
+ (BOOL)iosNot6x{
    return [[[UIDevice currentDevice] systemVersion] floatValue] >= 7.0f;
}

#pragma orientation 屏幕旋转
+ (CGFloat)screenHeight{
    return [[UIScreen mainScreen]bounds].size.height;
}
+ (CGFloat)screenWidth{
    return [[UIScreen mainScreen]bounds].size.width;
}
+ (CGRect)screenBounds{
    return [UIScreen mainScreen].bounds;
}
+ (CGRect)screenFrame{
    return [UIScreen mainScreen].bounds;
}
+ (CGSize)screenSize{
    return [[UIScreen mainScreen]bounds].size;
}

+ (CGRect)frameForOrientation: (UIInterfaceOrientation)orientation{
    CGRect frame;
    if (orientation == UIInterfaceOrientationLandscapeLeft || orientation == UIInterfaceOrientationLandscapeRight){
        //交替宽高
        CGRect bounds = [UIScreen mainScreen].bounds;
        frame = CGRectMake(bounds.origin.x, bounds.origin.y, bounds.size.height, bounds.size.width);
    }else{
        frame = [UIScreen mainScreen].bounds;
    } 
    return frame;
}

//判断当前屏幕是否横屏
+ (BOOL)screenLandscapeOrientation{
    UIInterfaceOrientation orientation = [UIApplication sharedApplication].statusBarOrientation;
    return (orientation == UIInterfaceOrientationLandscapeLeft || orientation == UIInterfaceOrientationLandscapeRight);
}

@end
