//
//  ElmViewController.m
//  SimilarElm
//
//  Created by SunLi on 16/7/2.
//  Copyright © 2016年 lb. All rights reserved.
//

#import "ElmViewController.h"
#import "IPhoneScreen.h"
#import "SeetingViewController.h"
#import "MineBlockViewItem.h"
#import "MineTableViewHeader.h"
#import "CommonHelper.h"

@interface ElmViewController() <UITableViewDataSource, UITableViewDelegate>
{
    CGFloat sectionHeight;
}
@property(nonatomic,strong)UITableView* tableView;
@property(nonatomic,strong)MineTableViewHeader* headView;
@property(nonatomic,strong)UIImageView* bigImageView;

//菜单项：收藏/消息／积分
@property(nonatomic, strong)MineBlockViewItem *menuCollection;
@property(nonatomic, strong)MineBlockViewItem *menuMessage;
@property(nonatomic, strong)MineBlockViewItem *menuScore;

@end
@implementation ElmViewController

- (void)viewDidLoad {
    sectionHeight = 6;
    [self initTableView];
    [self initHeaderView];
    [self initNavBarItems];
    [self initCustomTableView];
}



//初始化tableView
-(UITableView*)tableView
{
    if (!_tableView) {
        //分组tableView
        _tableView=[[UITableView alloc] initWithFrame:CGRectMake(0, 0,[IPhoneScreen screenWidth], [IPhoneScreen screenHeight])style:UITableViewStyleGrouped];
        // 设置tableView的背景颜色
        _tableView.backgroundView = nil;
        _tableView.backgroundColor = [CommonHelper rgb:244 andg:243 andb:241];
        _tableView.delegate=self;
        _tableView.dataSource=self;
    }
    return _tableView;
}

- (NSMutableArray *)dataList {
    if (_dataList == nil) {
        _dataList = [NSMutableArray array];
    }
    return _dataList;
}

-(void)initTableView
{
    [self.view addSubview: self.tableView];
    // 适配iOS7的组间距
    if ([IPhoneScreen version] >=7.0) {
        self.tableView.contentInset = UIEdgeInsetsMake(0, 0, 0, 0);
    }
}
-(void)viewWillAppear:(BOOL)animated{
    
    //去掉navbar的黑线,此处会删除父类tabViewController的navbar
    [self.navigationController.navigationBar setBackgroundImage:[[UIImage alloc]init] forBarMetrics:UIBarMetricsDefault];
    self.navigationController.navigationBar.shadowImage = [[UIImage alloc]init];
    self.navigationController.navigationBar.backgroundColor = [CommonHelper hexColor:@"#00B2EE"];
    
    UIView *statusBarView = [[UIView alloc] initWithFrame:CGRectMake(0, -20, [IPhoneScreen screenWidth], 20)];
    statusBarView.backgroundColor=[CommonHelper hexColor:@"#00B2EE"];
    [self.navigationController.navigationBar addSubview:statusBarView];
    self.tabBarController.tabBar.hidden = NO;
   
    self.navigationController.navigationBar.barTintColor = [CommonHelper hexColor:@"#00B2EE"];
    self.navigationController.navigationBar.tintColor = [UIColor whiteColor];
    //白色
    NSDictionary *attributes = [NSDictionary dictionaryWithObjectsAndKeys:
                                [UIColor whiteColor],NSForegroundColorAttributeName, nil];
    [self.navigationController.navigationBar setTitleTextAttributes:attributes];
    
    self.tabBarController.tabBar.hidden = YES;
    self.hidesBottomBarWhenPushed = YES;
}

-(void)initHeaderView
{
    
    CGFloat offHeight = self.navigationController.navigationBar.frame.size.height-12;
    _bigImageView=[[UIImageView alloc]initWithFrame:CGRectMake(0, offHeight, self.view.frame.size.width, 130)];
    _bigImageView.backgroundColor = [CommonHelper hexColor:@"#00B2EE"];
    _bigImageView.clipsToBounds=YES;  //超出部分隐藏
    _bigImageView.contentMode = UIViewContentModeScaleAspectFill;
    
    UIImageView* smallView=[[UIImageView alloc]initWithFrame:CGRectMake(0, 0, 80, 80)];
    smallView.backgroundColor = [UIColor whiteColor];
    smallView.image=[UIImage imageNamed:@"setting_user128"];   //头像user.png
    //smallView.center=CGPointMake(_bigImageView.center.x, _bigImageView.center.y);
    smallView.center = CGPointMake(_bigImageView.frame.origin.x + 60, _bigImageView.center.y-20);
    smallView.clipsToBounds=YES;
    smallView.contentMode=UIViewContentModeScaleAspectFill;
    
    _headView = [[MineTableViewHeader alloc]init];
    _headView.userName = @"admin";
    _headView.phone = @"18356014526";
    
    //菜单项
    self.menuCollection = [[MineBlockViewItem alloc]initWithFrame:CGRectMake(0, 0, ([IPhoneScreen screenWidth]-1)/3, 45)];
    [self.menuCollection initWithTitle:12 hType:@"条" hButtom:@"我的收藏" hColor:[UIColor orangeColor] ];
    self.menuMessage = [[MineBlockViewItem alloc]initWithFrame:CGRectMake(0, 0, ([IPhoneScreen screenWidth]/3-1), 45)];
    [self.menuMessage initWithTitle:15 hType:@"条" hButtom:@"我的消息" hColor:[UIColor redColor] ];
    self.menuScore = [[MineBlockViewItem alloc]initWithFrame:CGRectMake(0, 0, ([IPhoneScreen screenWidth]-1)/3, 45)];
    [ self.menuScore  initWithTitle:1456 hType:@"分" hButtom:@"我的积分" hColor:[UIColor greenColor] ];
    [_headView.navArray addObject:self.menuCollection];
    [_headView.navArray addObject:self.menuMessage];
    [_headView.navArray addObject: self.menuScore ];
    
    __weak typeof(self) weakSelf = self;
    _headView.operation = ^(NSInteger clickTag){
        NSLog(@"Click tag %ld", (long)clickTag);
        if (clickTag == 10){
          
            //[weakSelf.navigationController pushViewController:vc animated:YES];
        }else if (clickTag == 11){
            
        }else if (clickTag == 12){
            
        }else{
           //此处添加代码操作
        }
    };
    [_headView headerWithTableView:self.tableView backgroundView:_bigImageView subviews:smallView];
    
    self.automaticallyAdjustsScrollViewInsets = NO;
}

//初始化navbar Item
- (void)initNavBarItems
{
    UIButton*leftButton = [[UIButton alloc]initWithFrame:CGRectMake(0,0,30,30)];
    [leftButton setImage:[UIImage imageNamed:@"switchset.png"]forState:UIControlStateNormal];
    [leftButton addTarget:self action:@selector(switchButtonClick:)forControlEvents:UIControlEventTouchUpInside];
    leftButton.tag = 200;
    UIBarButtonItem*leftItem = [[UIBarButtonItem alloc]initWithCustomView:leftButton];
    self.navigationItem.leftBarButtonItem = leftItem;
    
    //右边navbarItem
    UIButton *rightButton = [[UIButton alloc]initWithFrame:CGRectMake(0, 0, 30, 30)];
    [rightButton setImage:[UIImage imageNamed:@"settings.png"] forState:UIControlStateNormal];
    [rightButton addTarget:self action:@selector(switchButtonClick:) forControlEvents:UIControlEventTouchUpInside];
    rightButton.tag = 201;
    UIBarButtonItem *rightItem = [[UIBarButtonItem alloc]initWithCustomView:rightButton];
    self.navigationItem.rightBarButtonItem = rightItem;
}
- (void)switchButtonClick:(UIButton *)button
{
    if (button.tag == 200){
        //代理传递按钮tag
        
    }else{
        SeetingViewController *vc = [[SeetingViewController alloc]init];
        vc.title = @"设置";
        [self.navigationController pushViewController:vc animated:YES];
    }
}

//初始化自定义tableView
- (void)initCustomTableView {
    // cell箭头名称
    self.icon_arrow = @"CellArrow";
    //    //设置相关参数
    //    //cell背景颜色
    //    self.backgroundColor_Normal = [UIColor whiteColor];
    //    //cell选中背景颜色
    //   self.backgroundColor_Selected = CFCellBackgroundColor_Highlighted;
    //    //cell右边Label字体
    //    self.rightLabelFont = [UIFont systemFontOfSize:15];
    //    //cell右边Label文字颜色
    //    self.rightLabelFontColor = CFRightLabelTextColor;
    MFSettingArrowItem *oneitem0 =[MFSettingArrowItem itemWithIcon:@"setting_video_heart" title:@"收货地址" destVcClass:[SeetingViewController class]];
    MFSettingArrowItem *oneitem1 =[MFSettingArrowItem itemWithIcon:@"setting_heart" title:@"我的收藏" destVcClass:[SeetingViewController class]];
    MFSettingArrowItem *oneitem2 =[MFSettingArrowItem itemWithIcon:@"setting_video_heart" title:@"美食相册" destVcClass:[SeetingViewController class]];
    MFSettingGroup *group1 = [[MFSettingGroup alloc] init];
    group1.headerHeight = 45;
    group1.items = @[oneitem0,oneitem1, oneitem2];
    
    MFSettingLabelArrowItem *titem2 =[MFSettingLabelArrowItem itemWithIcon:@"setting_service" title:@"推荐有奖" destVcClass:[SeetingViewController class]];
 
    __weak typeof(self) weakSelf = self;
    MFSettingLabelArrowItem *titem3 =[MFSettingLabelArrowItem itemWithIcon:@"setting_comment" title:@"积分商城"];
    titem3.text_right = @"0元好物在这里！";
    MFSettingLabelArrowItem *titem4 =[MFSettingLabelArrowItem itemWithIcon:@"setting_share" title:@"饿会员卡"];
    titem4.text_right = @"未开通";
    titem4.opration = ^{
        //此处执行操作，跳转到其他页面，其他雷同
    };
    titem3.opration = ^{
        
    };
    MFSettingGroup *group2 = [[MFSettingGroup alloc] init];
    group2.items = @[titem2,titem3,titem4];
    
    
    MFSettingLabelArrowItem *item5 =[MFSettingLabelArrowItem itemWithIcon:@"setting_play" title:@"服务中心" destVcClass:[SeetingViewController class]];
    MFSettingLabelArrowItem *item6 =[MFSettingLabelArrowItem itemWithIcon:@"setting_set" title:@"欢迎评分" destVcClass:[SeetingViewController class]];
    MFSettingLabelArrowItem *item7 =[MFSettingLabelArrowItem itemWithIcon:@"setting_set" title:@"我是商家" destVcClass:[SeetingViewController class]];
    MFSettingGroup *group4 = [[MFSettingGroup alloc] init];
    group4.items = @[ item5,item6,item7];
    group4.footerHeight = 50;
    
    [self.dataList addObject:group1];
    [self.dataList addObject:group2];
    [self.dataList addObject:group4];
    
}

#pragma mark - Table view data source
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return self.dataList.count;
}

//分组
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    MFSettingGroup *group = self.dataList[section];
    return group.items.count;
}

//初始化相关信息
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    // 创建cell
    MFSettingCell *cell = [[MFSettingCell class] cellWithTableView:tableView];
    // 设置参数
    cell.backgroundColor_Normal = self.backgroundColor_Normal;
    cell.backgroundColor_Selected = self.backgroundColor_Selected;
    cell.iconArrow = self.icon_arrow;
    cell.rightLabelFont = self.rightLabelFont;
    cell.rightLabelFontColor = self.rightLabelFontColor;
    
    // 取出模型
    MFSettingGroup *group = self.dataList[indexPath.section];
    MFSettingCellItem  *item = group.items[indexPath.row];
    // 传递模型
    cell.item = item;
    cell.indexPath = indexPath;
    return cell;
}

#pragma mark - UITableViewDelegate

- (CGFloat) tableView:(UITableView *)tableView heightForRowAtIndexPath :(NSIndexPath *)indexPath {
    MFSettingGroup *group = self.dataList[indexPath.section];
    MFSettingCellItem  *item = group.items[indexPath.row];
    return item.cellHeight > 0 ? item.cellHeight : 44;
}

- (CGFloat) tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section {
    MFSettingGroup *group = self.dataList[section];
    if(group.headerHeight > 0){
        return group.headerHeight;
    }
    else {
        if (section == 0) {
            return sectionHeight * 2;
        } else {
            return sectionHeight;
        }
    }
}

- (CGFloat)tableView:(UITableView *)tableView heightForFooterInSection:(NSInteger)section {
    MFSettingGroup *group = self.dataList[section];
    if(group.footerHeight > 0){
        return group.footerHeight;
    }
    else {
        return sectionHeight;
    }
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
    MFSettingGroup *group = self.dataList[section];
    return group.header;
}

- (NSString *)tableView:(UITableView *)tableView titleForFooterInSection:(NSInteger)section {
    MFSettingGroup *group = self.dataList[section];
    return group.footer;
}

- (UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section {
    MFSettingGroup *group = self.dataList[section];
    return group.headerView;
}

- (UIView *)tableView:(UITableView *)tableView viewForFooterInSection:(NSInteger)section {
    MFSettingGroup *group = self.dataList[section];
    return group.footerrView;
}

/**
 *  点击某一行cell
 */
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    // 取消选中
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    
    // 取出模型
    MFSettingGroup *group = self.dataList[indexPath.section];
    MFSettingCellItem  *item = group.items[indexPath.row];
    
    // 注册执行操作处理
    if (item.opration) {
        item.opration();
        return;
    }
}

@end
