//
//  MFIconArrowView.m
//  TableViewFull
//
//  Created by SunLi on 16/4/21.
//  Copyright © 2016年 lb. All rights reserved.
//

#import "MFIconArrowView.h"

@interface MFIconArrowView ()

@property(nonatomic, weak) UIButton *btn_Icon;

@property(nonatomic, weak) UIImageView *imgView;

@end

@implementation MFIconArrowView

- (instancetype)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
        //禁用交互
        UIButton *btn_Icon = [[UIButton alloc] init];
        btn_Icon.userInteractionEnabled = NO;
        btn_Icon.contentHorizontalAlignment = UIControlContentHorizontalAlignmentRight;
        self.btn_Icon = btn_Icon;
        
        [self addSubview:btn_Icon];
        
        //禁用交互
        UIImageView *imgView = [[UIImageView alloc] init];
        imgView.userInteractionEnabled = NO;
        self.imgView = imgView;
        [self addSubview:imgView];
    }
    return self;
}

- (void)layoutSubviews {
    [super layoutSubviews];
    
    CGFloat imgW = self.imgView.image.size.width;
    CGFloat imgH = self.imgView.image.size.height;
    self.btn_Icon.frame = CGRectMake(0, 0, self.frame.size.width - imgW * 1.5, self.frame.size.height);
    self.imgView.frame = CGRectMake(self.frame.size.width - imgW,(self.frame.size.height - imgH) / 2, imgW, imgH);
}

//设置图标箭头
- (void)setIconArrow:(NSString *)iconArrow{
    _iconArrow = iconArrow;
    if(self.iconArrow.length > 0){
        self.imgView.image = [UIImage imageNamed:self.iconArrow];
    }
}

//设置右边Button图标
-(void)setIcon_right:(NSString *)icon_right{
    _icon_right = icon_right;
    
    [self.btn_Icon setImage:[UIImage imageNamed:icon_right] forState:UIControlStateNormal];
    
}

@end
