//
//  MFLabelArrowView.m
//  TableViewFull
//
//  Created by SunLi on 16/4/21.
//  Copyright © 2016年 lb. All rights reserved.
//

#import "MFLabelArrowView.h"
#import "CommonHelper.h"

@interface MFLabelArrowView ()
//对声明的信息的弱引用随资源释放
@property(nonatomic, weak) UILabel *lbMsg;
@property(nonatomic, weak) UIImageView *imgView;

@end

@implementation MFLabelArrowView

- (instancetype)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
        //右边Label
        UILabel *lbMsg = [[UILabel alloc] init];
        self.lbMsg = lbMsg;
        [self addSubview:lbMsg];
        //箭头
        UIImageView *imgView = [[UIImageView alloc] init];
        imgView.userInteractionEnabled = NO;
        self.imgView = imgView;
        [self addSubview:imgView];
    }
    return self;
}

/**布局子视图*/
- (void)layoutSubviews {
    [super layoutSubviews];
    
    CGFloat imgW = self.imgView.image.size.width;
    CGFloat imgH = self.imgView.image.size.height;
    //Label
    self.lbMsg.frame = CGRectMake(0, 0, self.frame.size.width - imgW * 1.5, self.frame.size.height);
    //图片居中
    self.imgView.frame = CGRectMake(self.frame.size.width - imgW, (self.frame.size.height - imgH) / 2, imgW, imgH);
}

- (void)setIconArrow:(NSString *)iconArrow{
    _iconArrow = iconArrow;
    if(self.iconArrow.length > 0){
        self.imgView.image = [UIImage imageNamed:self.iconArrow];
    }
}

- (void)setText:(NSString *)text {
    _text = text;
    self.lbMsg.text = text;
    self.lbMsg.textColor = [CommonHelper hexColor:@"#a2a2a3"]; //CFRightLabelTextColor;
    self.lbMsg.font = [UIFont systemFontOfSize:15];
    //靠右拍立
    self.lbMsg.textAlignment = NSTextAlignmentRight;
}


-(void)setRightLabelFont:(UIFont *)rightLabelFont{
    _rightLabelFont = rightLabelFont;
    self.lbMsg.font = rightLabelFont;
}

-(void)setRightLabelFontColor:(UIColor *)rightLabelFontColor{
    _rightLabelFontColor = rightLabelFontColor;
    self.lbMsg.textColor = rightLabelFontColor;
}

@end
