//
//  MFSettingCell.h
//  TableViewFull
//
//  Created by SunLi on 16/4/21.
//  Copyright © 2016年 lb. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>

typedef void (^MFSettingItemOpration)();
/*
 *设置table cell 项
 */
@interface MFSettingCellItem : NSObject

/** cell高度 */
@property (nonatomic, assign) CGFloat cellHeight;

/** cell文本 */
@property(nonatomic, copy) NSString *title;

/** cell图标 */
@property(nonatomic, copy) NSString *icon;

/** cell子文本 */
@property(nonatomic, copy) NSString *subTitle;
/** cell 选中样式 */
@property(nonatomic, assign) UITableViewCellSelectionStyle cellSelectionStyle;

/** 使用block保存一段功能，在恰当的时候调用 */
@property(nonatomic, copy) MFSettingItemOpration opration;

//用图标和标题初始化
+ (instancetype)itemWithIcon:(NSString *)icon title:(NSString *)title;

//用标题进行初始化
+ (instancetype)itemWithTitle:(NSString *)title;
@end
