//
//  MineTableViewHeader.m
//  TableViewFull
//
//  Created by SunLi on 16/4/30.
//  Copyright © 2016年 lb. All rights reserved.
//

#import "MineTableViewHeader.h"
static CGFloat SperateWidth = 0.5;
static CGFloat BlockTotalHeight =75;

@interface MineTableViewHeader()

@property(nonatomic, strong)UIButton *button;
@end

@implementation MineTableViewHeader
{
    CGRect  initFrame;  //背景视图
    CGFloat defaultViewHeight;
    CGRect   subViewsFrame; //头像视图
    CGRect totalFrame;  ///背景颜色
    CGFloat defaultPicHeight;
    UITapGestureRecognizer *tapGesture;
}

- (instancetype)init{
    self = [super init];
    if (self){
        _navArray = [NSMutableArray array];
    }
    return self;
}

//头部视图
-(void)headerWithTableView:(UITableView*)tableView backgroundView:(UIView*)view subviews:(UIView*)subviews{
    _tableView = tableView;
    _backImageView = view;
    _picImageView = subviews;
    initFrame=_backImageView.frame;
    defaultViewHeight  = initFrame.size.height;
    subViewsFrame=_picImageView.frame;
    defaultPicHeight = subViewsFrame.size.height;
    
    totalFrame = initFrame;
    totalFrame.size.height = initFrame.size.height + BlockTotalHeight;
    //圆按钮视图
    _picImageView.layer.cornerRadius = _picImageView.frame.size.width / 2;
    //TableView头部视图
    UIView *headView = [[UIView alloc]initWithFrame:totalFrame];//initFrame
    headView.backgroundColor = [_backImageView backgroundColor];
    self.tableView.tableHeaderView = headView;
 
    _button = [UIButton buttonWithType:UIButtonTypeCustom];
    [_button addTarget:self action:@selector(clickButton:) forControlEvents:UIControlEventTouchUpInside];
    _button.frame = initFrame;
    _button.tag = 100;
    [_button addSubview:_backImageView];
    [_button addSubview:_picImageView];
    [_tableView addSubview:_button];
    
    //Label
    if (_userName != nil){
        UILabel *userLabel = [[UILabel alloc]initWithFrame:CGRectMake(CGRectGetMaxX(subViewsFrame)+20, CGRectGetMinY(subViewsFrame)+defaultPicHeight/2-20, 300, 25)];
        userLabel.text = _userName;
        userLabel.font = [UIFont systemFontOfSize:20 weight:0.6];
        userLabel.textColor = [UIColor whiteColor];
        [_button addSubview:userLabel];
    }
    if (_phone != nil){
        UIImageView *imgView = [[UIImageView alloc]initWithFrame:CGRectMake(CGRectGetMaxX(subViewsFrame)+20, CGRectGetMinY(subViewsFrame)+defaultPicHeight/2+5, 12, 20)];
        imgView.image = [UIImage imageNamed:@"phone.png"];
        imgView.contentMode = UIViewContentModeScaleAspectFill;
        
        UILabel *phoneLabel = [[UILabel alloc]initWithFrame:CGRectMake(CGRectGetMaxX(subViewsFrame)+32, CGRectGetMinY(subViewsFrame)+defaultPicHeight/2+5, 300, 20)];
       
        phoneLabel.font = [UIFont systemFontOfSize:12 weight:0.6];
        if (_phone.length >4){
            NSString *prev = [_phone substringWithRange:NSMakeRange(0, 3)];
            NSString *suff = [_phone substringWithRange:NSMakeRange(_phone.length - 4, 4)];
            phoneLabel.text = [NSString stringWithFormat:@"%@****%@",prev, suff];
        }
        phoneLabel.textColor = [UIColor whiteColor];
        
        [_button addSubview:imgView];
        [_button addSubview:phoneLabel];
    }
    
    UIImageView *navImgView = [[UIImageView alloc]initWithFrame:CGRectMake(initFrame.size.width - 25, CGRectGetMinY(subViewsFrame)+defaultPicHeight/2-6, 12, 12)];
    navImgView.image = [UIImage imageNamed:@"CellArrow"];
    navImgView.contentMode = UIViewContentModeCenter;
    [_button addSubview:navImgView];
    
    //添加导航视图
    CGFloat totalWidth =  _tableView.bounds.size.width;
    UIView *navView = [[UIView alloc]initWithFrame:CGRectMake(0, CGRectGetMaxY(initFrame) , totalWidth, BlockTotalHeight)];
    navView.backgroundColor = [UIColor whiteColor];

    //每个View的宽度
    CGFloat perWidth = (totalWidth - 2 * SperateWidth)/3;
    for (int i = 0; i < _navArray.count; i++) {
        UIView *view = [self.navArray objectAtIndex:i];
        view.userInteractionEnabled = YES;
        view.tag = 10+i;
        //添加手势
        tapGesture =[[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(event:)];
        [view addGestureRecognizer:tapGesture];
    
        if (i <= 0){
            view.frame = CGRectMake(0, 0, perWidth, BlockTotalHeight);
            [navView addSubview:view];
        }
        else{
            //分隔符
            UIView *sperateView = [[UIView alloc]initWithFrame:CGRectMake(i *perWidth, 0, SperateWidth, BlockTotalHeight)];
            sperateView.backgroundColor = [UIColor lightGrayColor];
            view.frame = CGRectMake(i * perWidth + i * SperateWidth, 0, perWidth, BlockTotalHeight);
            [navView addSubview:sperateView];
            [navView addSubview:view];
        }
    }
    [_tableView addSubview:navView];
}

- (void)scrollViewDidScroll:(UIScrollView*)scrollView
{
    CGRect f  = _backImageView.frame;
    f.size.width = _tableView.frame.size.width;
    _backImageView.frame  = f;
    
    if (scrollView.contentOffset.y<0) {
        CGFloat offset = (scrollView.contentOffset.y + scrollView.contentInset.top) * -1;
        
        initFrame.origin.x= - offset /2;
        initFrame.origin.y= - offset;
        initFrame.size.width=_tableView.frame.size.width+offset;
        initFrame.size.height=defaultViewHeight+offset;
        _backImageView.frame=initFrame;
        
        [self viewLayoutSubviews:offset/2];
    }
}

//头像视图
- (void)viewLayoutSubviews:(CGFloat)offset
{
    _picImageView.frame=CGRectMake(0, 0, 80+offset, 80+offset);
    //_picImageView.center=CGPointMake(_backImageView.center.x, _backImageView.center.y);
    _picImageView.center = CGPointMake(_backImageView.frame.origin.x + 60, _backImageView.center.y);
    _picImageView.layer.cornerRadius=_picImageView.frame.size.width/2;
    
}

- (void)resizeView
{
    initFrame.size.width = _tableView.frame.size.width;
    _backImageView.frame = initFrame;
}

-(void)clickButton:(UIButton *)button
{
    if (self.operation){
        self.operation(button.tag);
    }
    //NSLog(@"Click Tag:%ld", button.tag);
}

- (void)event:(UITapGestureRecognizer *)gesture
{
    if (self.operation){
        self.operation(gesture.view.tag);
    }
    // NSLog(@"Click Tag:%ld", gesture.view.tag);
}
@end
